package test;

import java.io.IOException;
import java.net.URL;
import java.util.logging.Logger;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLSession;
import javax.xml.namespace.QName;
import javax.xml.ws.Service;
import javax.xml.ws.WebEndpoint;
import javax.xml.ws.WebServiceClient;
import javax.xml.ws.WebServiceFeature;

import ro.bvb.Financials;

/**
 * ssl connection without setHostnameVerifier
 */
@WebServiceClient(name = "FinancialsWebService", targetNamespace = "http://www.bvb.ro", wsdlLocation = "https://195.28.176.74/bvbfinancialsWS/financials.asmx?WSDL")
public class FinancialsWebServiceSsl extends Service {
    
    private final static URL FINANCIALSWEBSERVICE_WSDL_LOCATION;
    private final static Logger logger = Logger.getLogger(ro.bvb.FinancialsWebService.class.getName());
    
    static {
        URL url = null;
        try {
            URL baseUrl;
            baseUrl = ro.bvb.FinancialsWebService.class.getResource(".");
            url = new URL(baseUrl, "https://195.28.176.74/bvbfinancialsWS/financials.asmx?WSDL");
            HttpsURLConnection connection = (HttpsURLConnection) url.openConnection();
            connection.setHostnameVerifier(new HostnameVerifier() {
                @Override
                public boolean verify(String hostname, SSLSession session) {
                    return true;
                }
            });
            connection.connect();
        } catch (IOException e) {
            logger
                    .warning("Failed to create URL for the wsdl Location: 'https://195.28.176.74/bvbfinancialsWS/financials.asmx?WSDL', retrying as a local file");
            logger.warning(e.getMessage());
        }
        FINANCIALSWEBSERVICE_WSDL_LOCATION = url;
    }
    
    public FinancialsWebServiceSsl(URL wsdlLocation, QName serviceName) {
        super(wsdlLocation, serviceName);
    }
    
    public FinancialsWebServiceSsl() {
        super(FINANCIALSWEBSERVICE_WSDL_LOCATION, new QName("http://www.bvb.ro", "FinancialsWebService"));
    }
    
    /**
     * 
     * @return returns Financials
     */
    @WebEndpoint(name = "Financials")
    public Financials getFinancials() {
        return super.getPort(new QName("http://www.bvb.ro", "Financials"), Financials.class);
    }
    
    /**
     * 
     * @param features
     *            A list of {@link javax.xml.ws.WebServiceFeature} to configure on the proxy. Supported features not in
     *            the <code>features</code> parameter will have their default values.
     * @return returns Financials
     */
    @WebEndpoint(name = "Financials")
    public Financials getFinancials(WebServiceFeature... features) {
        return super.getPort(new QName("http://www.bvb.ro", "Financials"), Financials.class, features);
    }
    
}
