package test;

import java.util.Set;

import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPHeader;
import javax.xml.soap.SOAPMessage;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.soap.SOAPHandler;
import javax.xml.ws.handler.soap.SOAPMessageContext;

public class JAXWSHandler implements SOAPHandler<SOAPMessageContext> {
    
    @Override
    public Set<QName> getHeaders() {
        return null;
    }
    
    @Override
    public void close(MessageContext context) {
    }
    
    @Override
    public boolean handleFault(SOAPMessageContext context) {
        return false;
    }
    
    @Override
    public boolean handleMessage(SOAPMessageContext context) {
        Boolean outboundProperty = (Boolean) context.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY);
        
        try {
            SOAPMessage message = context.getMessage();
            
            if (outboundProperty.booleanValue()) {
                System.out.println("\nOutbound message:");
                SOAPEnvelope envelope;
                envelope = message.getSOAPPart().getEnvelope();
                SOAPHeader header = envelope.addHeader();
                
                SOAPElement myHeader = header.addChildElement("Header", "ns", TestBVBClient2.namespace);                
                SOAPElement node1 = myHeader.addChildElement("User","ns");
                node1.addTextNode("user");                
                SOAPElement node2 = myHeader.addChildElement("Password", "ns");
                node2.setValue("password");



            } else {
                System.out.println("\nInbound message:");
            }
            
            message.writeTo(System.out);
            System.out.println("");
            
        } catch (Exception e) {
            e.printStackTrace();
        }
        return true;
    }
    
}
