package test;

import java.util.List;

import javax.xml.ws.Binding;
import javax.xml.ws.BindingProvider;
import javax.xml.ws.WebServiceRef;
import javax.xml.ws.handler.Handler;

import ro.bvb.*;

public class TestBVBClient2 {
    
    // private static final String SOAP_ACTION = "http://bvb.ro/HelloWorld";
    // static final String wsdlURL = "https://www.bvb.ro/bsewstest/test.asmx?WSDL";
    static final String namespace = "http://www.bvb.ro";
    // static final String serviceName = "Test";
    // static final String port = "TestSoap";
    // static final String callName = "HelloWorld";
    // static final String endPoint = "http://195.28.176.74/bvbfinancialsWS/financials.asmx";
    
    @WebServiceRef
    static FinancialsWebService service = new FinancialsWebService();
    
    @WebServiceRef
    static FinancialsWebServiceSsl serviceWithSsl = new FinancialsWebServiceSsl();
    
    public static void main(String[] args) {
        try {
            TestBVBClient2 client = new TestBVBClient2();
            client.doTestJAXWS(); // OK cu JaxWs fara ssl 
            client.doTestJAXWS_ssl(); // OK cu JaxWs si clientul FinancialsWebServiceSsl rescris 
            // client.consumeRPC(); // rcp nu merge
            // client.withSoap(); // nu merge
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    // cu jax-ws - OK
    public void doTestJAXWS() {
        try {
            Financials soap = service.getFinancials();
            // add handler petru client
            Binding binding = ((BindingProvider) soap).getBinding();
            List<Handler> handlerList = binding.getHandlerChain();
            handlerList.add(new JAXWSHandler());
            binding.setHandlerChain(handlerList);
            
            ArrayOfSymbolBalanceTypeIdentification response = soap.getAvailableBalances(2011, ReportTypeEnum.Q_1);
            for (SymbolBalanceTypeIdentification r : response.getSymbolBalanceTypeIdentification()) {
                System.out.println(r.getSymbol() + " " + r.getYear() + "" + r.getBalanceType() + " "
                        + r.getReportType());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    // cu jax-ws cu ssl- OK
    public void doTestJAXWS_ssl() {
        try {
            Financials soap = serviceWithSsl.getFinancials();
            
            // add handler petru client
            Binding binding = ((BindingProvider) soap).getBinding();
            List<Handler> handlerList = binding.getHandlerChain();
            handlerList.add(new JAXWSHandler());
            binding.setHandlerChain(handlerList);
            
            ArrayOfSymbolBalanceTypeIdentification response = soap.getAvailableBalances(2011, ReportTypeEnum.Q_1);
            for (SymbolBalanceTypeIdentification r : response.getSymbolBalanceTypeIdentification()) {
                System.out.println(r.getSymbol() + " " + r.getYear() + "" + r.getBalanceType() + " "
                        + r.getReportType());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    // cu rpc
    /*
        public void consumeRPC() throws ServiceException, MalformedURLException, RemoteException {
            
            QName serviceQN = new QName(namespace, serviceName);
            javax.xml.rpc.ServiceFactory serviceFactory = javax.xml.rpc.ServiceFactory.newInstance();
            javax.xml.rpc.Service service = serviceFactory.createService(new URL(wsdlURL), serviceQN);
            
            // Call object
            javax.xml.rpc.Call call = service.createCall();
            QName operationName = new QName(namespace, callName);
            call.setOperationName(operationName);
            
            // setting return type
            call.setReturnType(XMLType.XSD_STRING);
            
            // specify the RPC-style operation.
            call.setProperty(Call.OPERATION_STYLE_PROPERTY, "rpc");
            call.setProperty(Call.ENCODINGSTYLE_URI_PROPERTY, "http://schemas.xmlsoap.org/soap/encoding/");
            call.setProperty(Call.SOAPACTION_URI_PROPERTY, SOAP_ACTION);
            
            call.setTargetEndpointAddress(endPoint);
            
            // add handler
            // !!! nu functioneza handlerul
            List handlerChain = new ArrayList();
            handlerChain.add(new HandlerInfo(SimpleRPCHandler.class, null, null));
            service.getHandlerRegistry().setHandlerChain(operationName, handlerChain);
            
            String returnVal = (String) call.invoke(new Object[] {});
            System.out.println("return value:  " + returnVal.toString());
        }
        */

    // soap
    /*
    public void withSoap() {
        
        try {
            // First create the connection
            SOAPConnectionFactory soapConnFactory = SOAPConnectionFactory.newInstance();
            SOAPConnection connection = soapConnFactory.createConnection();
            
            // Next, create the actual message
            MessageFactory messageFactory = MessageFactory.newInstance();
            SOAPMessage message = messageFactory.createMessage();
            
            // MimeHeaders headers = message.getMimeHeaders();
            // headers.addHeader("SOAPAction", "http://bvb.ro/HelloWorld");
            
            SOAPPart soapPart = message.getSOAPPart();
            SOAPEnvelope envelope = soapPart.getEnvelope();
            envelope.addNamespaceDeclaration("xsd", "http://www.w3.org/2001/XMLSchema");
            envelope.addNamespaceDeclaration("xsi", "http://www.w3.org/2001/XMLSchema-instance");
            envelope.addNamespaceDeclaration("enc", "http://schemas.xmlsoap.org/soap/encoding/");
            envelope.addNamespaceDeclaration("env", "http://schemas.xmlsoap.org/soap/envelope/");
            envelope.setEncodingStyle("http://schemas.xmlsoap.org/soap/encoding/");
            
            soapPart.setMimeHeader("SOAPAction", SOAP_ACTION);
            
            // This method demonstrates how to set HTTP and SOAP headers.
            setOptionalSoapHeaders(message, envelope);
            
            // Create and populate the body
            SOAPBody body = envelope.getBody();
            
            // Create the main element and namespace
            SOAPElement bodyElement = body.addChildElement(envelope.createName(callName, "ns1", namespace));
            // Save the message
            message.saveChanges();
            
            // Display the message that would be sent
            System.out.println("\n----- Request Message ----\n");
            message.writeTo(System.out);
            
            // Send the message and get the reply
            SOAPMessage reply = connection.call(message, endPoint);
            
            // Retrieve the result
            soapPart = reply.getSOAPPart();
            envelope = soapPart.getEnvelope();
            body = envelope.getBody();
            
            System.out.println(soapPart.toString());
            
            connection.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }
    
    */

    /*
    private void setOptionalSoapHeaders(SOAPMessage message, SOAPEnvelope envelope) throws SOAPException {
        
        SimpleDateFormat dateFormatter = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        String xmldate = dateFormatter.format(new Date()).toString();
        
        SOAPHeader header = message.getSOAPHeader();
        if (header == null)
            header = envelope.addHeader();
        
        // Will use the default actor "next" for this example,
        // otherwise use he.setActor(String actorURI) to define actor.
        SOAPHeaderElement he = header.addHeaderElement(envelope.createName("Header", "ns", namespace));
        SOAPElement he1 = he.addChildElement("Created", "ns", namespace);
        SOAPElement he2 = he.addChildElement("Expires", "ns", namespace);
        he.setMustUnderstand(false);
        he1.setValue(xmldate);
        he2.setValue("100");
        // end: setting SOAP headers
    }
    
    */
}

/*

class SimpleRPCHandler extends GenericHandler {
    HandlerInfo hi = null;
    
    public void init(HandlerInfo info) {
        hi = info;
    }
    
    public QName[] getHeaders() {
        return hi.getHeaders();
    }
    
    public boolean handleResponse(MessageContext context) {
        System.out.println("response");
        try {
            // get the soap header
            SOAPMessageContext smc = (SOAPMessageContext) context;
            SOAPMessage message = smc.getMessage();
            print(message);
        } catch (Exception e) {
            throw new JAXRPCException(e);
        }
        return true;
    }
    
    public boolean handleRequest(MessageContext context) {
        System.out.println("request");
        try {
            // get the soap header
            SOAPMessageContext smc = (SOAPMessageContext) context;
            SOAPMessage message = smc.getMessage();
            print(message);
        } catch (Exception e) {
            throw new JAXRPCException(e);
        }
        return true;
    }
    
    private void print(SOAPMessage message) throws SOAPException, TransformerException {
        // Create transformer
        TransformerFactory tff = TransformerFactory.newInstance();
        Transformer tf = tff.newTransformer();
        
        // Get reply content
        Source sc = message.getSOAPPart().getContent();
        
        // Set output transformation
        StreamResult result = new StreamResult(System.out);
        tf.transform(sc, result);
        System.out.println();
    }
}
*/